Imports System.Data
Imports System.Data.OleDb

Partial Class PortOps
    Inherits System.Web.UI.Page

#Region "Member Variables"
    Dim connString As String = _
ConfigurationSettings.AppSettings("ConnString")
#End Region

#Region "Event Handlers"

    Protected Sub Page_Load(ByVal sender As Object, _
    ByVal e As System.EventArgs) Handles Me.Load
        If Not Session("InvestorID") Is Nothing Then
            Session("PageTitle") = Request.Params("op") & " Portfolio"
            If Request.Params("op") = "Edit" Then
                txtPortName.Visible = False
                cmdCreate.Visible = False
            ElseIf Request.Params("op") = "Add" Then
                cmdAdd.Visible = False
                cmdDelete.Visible = False
                dgrPortDetails.Visible = False
            End If
            lblMsg.Text = ""
        Else
            Response.Redirect("Index.aspx")
        End If
    End Sub

    Protected Sub cmdCreate_Click(ByVal sender As Object, _
    ByVal e As System.EventArgs) Handles cmdCreate.Click
        Dim dsCreateNewPortfolio As New AccessDataSource
        'Get the new PID
        Session("SelectedPID") = GetMaxPID() + 1
        dsCreateNewPortfolio.DataFile = "./database/Portfolio.mdb"
        dsCreateNewPortfolio.InsertCommand = _
        "INSERT INTO tblPortfolio (PID,InvestorID,Name) VALUES (" _
        & Session("SelectedPID") & "," & Session("InvestorID") & _
        ",'" & txtPortName.Text & "')"
        dsCreateNewPortfolio.Insert()
        Response.Redirect("PortOps.aspx?op=Edit")
    End Sub

    Protected Sub dgrPortDetails_RowUpdating(ByVal sender As Object, _
    ByVal e As System.Web.UI.WebControls.GridViewUpdateEventArgs) _
    Handles dgrPortDetails.RowUpdating
        Dim quantity As Integer
        Dim symbol As String

        quantity = CInt(CType(dgrPortDetails.Rows _
        (dgrPortDetails.EditIndex).Cells(4).Controls(0), TextBox).Text)
        symbol = dgrPortDetails.Rows(dgrPortDetails.EditIndex).Cells(1).Text
        dsPortfolioDetails.UpdateCommand = _
        "UPDATE tblPortfolioDetail SET Quantity=" & quantity & _
        " WHERE Symbol='" & symbol & "' AND PID=" & Session("SelectedPID")
        dsPortfolioDetails.Update()
    End Sub

    Private Sub cmdAdd_Click(ByVal sender As System.Object, _
    ByVal e As System.EventArgs) Handles cmdAdd.Click
        Dim dsInsertPortfolioDetail As New AccessDataSource
        If lstStock.SelectedIndex = -1 Then
            lblMsg.Text = "Please select the stock to add!!"
            Exit Sub
        End If
        dsInsertPortfolioDetail.DataFile = "./database/Portfolio.mdb"
        dsInsertPortfolioDetail.InsertCommand = _
        "INSERT INTO tblPortfolioDetail (PID,Symbol,Quantity) VALUES (" _
        & Session("SelectedPID") & ",'" & lstStock.SelectedValue & "',10)"
        Try
            dsInsertPortfolioDetail.Insert()
            dgrPortDetails.DataBind()
        Catch
            lblMsg.Text = "The stock already exists in the portfolio."
        End Try
    End Sub

    Private Sub cmdDelete_Click(ByVal sender As System.Object, _
    ByVal e As System.EventArgs) Handles cmdDelete.Click
        Dim deleted As Integer
        Dim symbol As String
        Dim dsDeletePortfolioDetail As New AccessDataSource
        If dgrPortDetails.SelectedIndex = -1 Then
            lblMsg.Text = "Please select the stock to delete!!"
            Exit Sub
        End If
        symbol = dgrPortDetails.SelectedRow.Cells(1).Text
        dsDeletePortfolioDetail.DataFile = "./database/Portfolio.mdb"
        dsDeletePortfolioDetail.DeleteCommand = _
        "DELETE FROM tblPortfolioDetail WHERE Symbol='" & symbol _
        & "' AND PID=" & Session("SelectedPID")
        deleted = dsDeletePortfolioDetail.Delete()
        dgrPortDetails.DataBind()
        lblMsg.Text = deleted & " row(s) deleted."
    End Sub

#End Region

#Region "Member Functions"

    Public Function GetMaxPID() As Integer
        Dim connDb As New OleDbConnection(connString)
        Dim cmdQuery As New OleDbCommand("", connDb)
        Dim pid As Integer
        connDb.Open()
        cmdQuery.CommandType = CommandType.StoredProcedure
        cmdQuery.CommandText = "qryGetLastPID"
        pid = CInt(cmdQuery.ExecuteScalar)
        connDb.Close()
        Return pid
    End Function

#End Region

End Class
