Imports System.Data
Imports System.Data.OleDb

Partial Class Portal
    Inherits System.Web.UI.Page

#Region "Event Handlers"

    Protected Sub Page_Load(ByVal sender As Object, _
    ByVal e As System.EventArgs) Handles Me.Load
        If Not Session("InvestorID") Is Nothing Then
            Session("PageTitle") = "Investor's Portal"
        Else
            Response.Redirect("Index.aspx")
        End If
        'Select the first portfolio
        If Not IsPostBack Then
            lstPort.SelectedIndex = 0
        End If
        loadReport() 'Load the crystal report
    End Sub

    Protected Sub cmdEdit_Click(ByVal sender As Object, _
    ByVal e As System.EventArgs) Handles cmdEdit.Click
        Session("SelectedPID") = CInt(lstPort.SelectedValue)
        Response.Redirect("PortOps.aspx?op=Edit")
    End Sub

    Protected Sub cmdOpt_Click(ByVal sender As Object, _
    ByVal e As System.EventArgs) Handles cmdOpt.Click
        Session("SelectedPID") = CInt(lstPort.SelectedValue)
        Response.Redirect("Optimization.aspx")
    End Sub

    Protected Sub cmdDelete_Click(ByVal sender As Object, _
    ByVal e As System.EventArgs) Handles cmdDelete.Click
        Session("SelectedPID") = CInt(lstPort.SelectedValue)
        Dim dsDeletePortfolio As New AccessDataSource
        Dim deleted As Integer
        dsDeletePortfolio.DataFile = "./database/Portfolio.mdb"
        dsDeletePortfolio.DeleteCommand = _
        "DELETE FROM tblPortfolio WHERE InvestorID=" _
        & Session("InvestorID") & " AND PID=" & Session("SelectedPID")
        deleted = dsDeletePortfolio.Delete()
        lblMsg.Text = deleted & " row(s) deleted."
        Response.Redirect("Portal.aspx")
    End Sub

#End Region

#Region "Member Functions"

    Public Sub loadReport()
        Dim myConnection As New OleDbConnection
        Dim myCommand As New OleDbCommand
        Dim myDA As New OleDbDataAdapter
        Dim myDS As New DataSet

        myConnection.ConnectionString = _
        ConfigurationManager.AppSettings("connString")
        myCommand.Connection = myConnection
        myCommand.CommandText = "Select InvestorID, Name, Value " _
        & "from qryForOneInvID where InvestorID = " & Session("InvestorID")
        myCommand.CommandType = CommandType.Text
        myDA.SelectCommand = myCommand

        myCommand.Connection.Open()
        myDA.Fill(myDS, "qryForOneInvID")
        Dim oRpt As New CrystalDecisions.CrystalReports.Engine.ReportDocument
        oRpt.FileName = "C:\webdss\casestudies\Portfolio\rptPieChart.rpt"
        oRpt.SetDataSource(myDS)
        rptViewer1.ReportSource = oRpt
        myCommand.Connection.Close()
    End Sub

#End Region


End Class
